; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;	Patcher Pour UPXUnpackme de Clandestino
;	par Lise_Grim
; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.486

.model	flat, stdcall 
option	casemap :none
; -----------------------------------------------------------------------------------
;	INClUDES ET DEFINITIONS
; -----------------------------------------------------------------------------------

include		\masm32\include\windows.inc 
include		\masm32\include\kernel32.inc 
include		\masm32\include\comdlg32.inc 
include		\masm32\include\user32.inc
include		\masm32\include\shell32.inc
include		\masm32\include\advapi32.inc

includelib	\masm32\lib\user32.lib 
includelib	\masm32\lib\kernel32.lib 
includelib	\masm32\lib\comdlg32.lib
includelib	\masm32\lib\shell32.lib
includelib	\masm32\lib\advapi32.lib

WndProc			PROTO :DWORD, :DWORD, :DWORD, :DWORD
OpenTarget		PROTO :DWORD
PatchFile		PROTO :DWORD, :DWORD, :DWORD

; -----------------------------------------------------------------------------------
;	DATA
; -----------------------------------------------------------------------------------
.data
;---- Data  patcher
BytesSaut		db 0EBh, 27h
BytesMoteur		db 60h, 33h, 0C9h, 0B1h, 23h, 8Ah, 99h, 90h, 0ABh, 41h, 00h
			db 88h, 99h, 0C7h, 86h, 40h, 00h, 0E2h, 0F2h, 61h, 0E9h, 07h
			db 0DEh, 0FEh, 0FFh
;---- File Stuff
FilePath		db 512 dup (0)
FileCopy		db 512 dup (0)
TitleFileOpen		db "Slectionnez le crackme...",0
FilterString		db "Exe Files (*.exe)", 0, "*.exe", 0 
			db "All Files", 0, "*.*", 0, 0
ofn 			OPENFILENAME <>
;----- Rsultat
Resultat_LongNom	db "J'ai dit <  34 lettres !",0
Resultat_PasNom		db "Pas de phrase donne :P",0
Resultat_Init		db "Prt  patcher !",0
Resultat_ErrorOpen	db "Le fichier n'a pu tre ouvert !",0
Resultat_ErrorMapping	db "Problme ! Erreur de Mapping.",0
Resultat_ErrorPE	db "Le fichier n'est pas un PE Format !",0
Resultat_Success	db "Fichier patch avec succs !",0
;----- Nom
Nom_Init		db "UPX  patche par Lise_Grim[FFF]",0
BUF_NOM			db 40 dup (0)

; -----------------------------------------------------------------------------------
;	DATA?
; -----------------------------------------------------------------------------------
.data?

hInstance		HINSTANCE ? 
hFile 			dd ? 
hMapping 		dd ? 
pMapping 		dd ?
ValidPE			dd ?
NB_NOM			dd ?
; -----------------------------------------------------------------------------------
;	CONSTANTES
; -----------------------------------------------------------------------------------
.const

IDD_DIALOGBOX	equ	101
IDI_ICON	equ	102
IDC_PATCH	equ	1001
IDC_EXIT	equ	1002
IDC_BACKUP	equ	1003
IDC_NOM		equ	1004
IDC_RESULTAT	equ	1005
IDC_STATIC	equ	-1
; -----------------------------------------------------------------------------------
;	CODE
; -----------------------------------------------------------------------------------
.code

start:
    	invoke	GetModuleHandle, NULL 
    	mov	hInstance, eax 
	invoke	DialogBoxParam, hInstance, IDD_DIALOGBOX, 0, ADDR WndProc, 0
   	invoke	ExitProcess, eax
; *********************************************************************
WndProc		PROC	hWin	:DWORD,
			uMsg	:DWORD,
			wParam	:DWORD,
			lParam	:DWORD

	.if	uMsg == WM_INITDIALOG

	xor	eax, eax
	invoke	LoadIcon, hInstance, IDI_ICON
	invoke	SendMessage, hWin, WM_SETICON, ICON_BIG, eax
	invoke	SetDlgItemText, hWin, IDC_NOM, offset Nom_Init
	invoke	SetDlgItemText, hWin, IDC_RESULTAT, offset Resultat_Init
	invoke	CheckDlgButton, hWin, IDC_BACKUP, TRUE
	 
	.elseif	uMsg == WM_COMMAND

	;---------------- PATCH --------------------    
	.if	wParam == IDC_PATCH
		invoke	GetDlgItemText, hWin, IDC_NOM, offset BUF_NOM, 40
		mov	NB_NOM, eax
		test	eax, eax
		jle	Pas_Nom

		cmp	eax, 34
		jg	Long_Nom
		invoke	OpenTarget, hWin
		jmp	Fin_Patch

		Pas_Nom:
		invoke	SetDlgItemText, hWin, IDC_RESULTAT, offset Resultat_PasNom
		jmp	Fin_Patch

		Long_Nom:
		invoke	SetDlgItemText, hWin, IDC_RESULTAT, offset Resultat_LongNom
		Fin_Patch:
		invoke	RtlZeroMemory, offset BUF_NOM, 40

    
	;---------------- EXIT --------------------
	.elseif	wParam == IDC_EXIT
	 invoke	EndDialog,hWin,eax
	.endif

	.elseif	uMsg == WM_CLOSE
	 invoke	EndDialog,hWin,0

	.elseif	uMsg == WM_LBUTTONDOWN
	 mov	eax, lParam
	 invoke	PostMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,eax
	.endif

	 xor	eax, eax
	 ret

WndProc		ENDP
; -------------------------------------------------------------------------------
PatchFile	PROC	NombreBytes :DWORD, offsetBytes :DWORD, offsetFile :DWORD
	pushad
	; patch saut
	mov	eax, pMapping
	add	eax, offsetFile
	mov	ecx, NombreBytes
	mov	esi, offsetBytes
	
	Patch_Loop:
	mov	bl, byte ptr [esi+ecx-1]
	mov	byte ptr [eax+ecx-1], bl
	loop	Patch_Loop
	

	popad
	ret
PatchFile	ENDP

; -------------------------------------------------------------------------------
;	OpenTarget = modification de la procdure de Morg@tte
; -------------------------------------------------------------------------------
OpenTarget	PROC uses edi  hDlg :DWORD

	mov	ofn.lStructSize, SIZEOF ofn
	mov	ofn.lpstrFilter, offset FilterString
	mov	ofn.lpstrFile, offset FilePath
	mov	ofn.nMaxFile,512
	mov	ofn.lpstrTitle, offset TitleFileOpen
	mov	ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
	invoke	GetOpenFileName, offset ofn
	.if eax == TRUE
		FilePathOk:
		invoke	IsDlgButtonChecked, hDlg, IDC_BACKUP
		cmp	eax, BST_CHECKED
		jnz	FileOpen

		invoke	lstrcpy, offset FileCopy, offset FilePath     
		mov	edi, offset FileCopy 
		xor	al, al
		scasb   
		jnz	$-1
		mov	dword ptr [edi-1], 'kab.'
		invoke	DeleteFile, offset FileCopy
		invoke	CopyFile, offset FilePath, offset FileCopy, FALSE
		FileOpen:
		invoke	CreateFile, offset FilePath, GENERIC_READ+GENERIC_WRITE, FILE_SHARE_READ,\
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
		.if	eax != INVALID_HANDLE_VALUE
			mov	hFile, eax
			invoke	CreateFileMapping, hFile, NULL, PAGE_READWRITE, 0, 0, 0
			.if	eax != NULL
				mov	hMapping, eax
				invoke	MapViewOfFile, hMapping, FILE_MAP_WRITE, 0, 0, 0
				.if	eax != NULL
					mov	pMapping, eax
					mov	edi, pMapping
					assume	edi: ptr IMAGE_DOS_HEADER
					.if	[edi].e_magic == IMAGE_DOS_SIGNATURE
						add	edi, [edi].e_lfanew
						assume	edi:ptr IMAGE_NT_HEADERS
						.if	[edi].Signature == IMAGE_NT_SIGNATURE
							mov	ValidPE, TRUE
						.else
							mov	ValidPE, FALSE
						.endif
					.else
						mov	ValidPE, FALSE
					.endif

					.if	ValidPE == TRUE
						; Patch du saut			
						invoke	PatchFile, 2, offset BytesSaut, 0AF4Fh
						; Patch du moteur
						invoke	PatchFile, 25, offset BytesMoteur, 0AF78h
						; Patch de la String
						inc	NB_NOM	; pour patcher aussi le 0 hexa (fin de string)
						invoke	PatchFile, NB_NOM, offset BUF_NOM, 0AF91h
						invoke	SetDlgItemText, hDlg, IDC_RESULTAT, offset Resultat_Success

					.else
						invoke	SetDlgItemText, hDlg, IDC_RESULTAT, offset Resultat_ErrorPE
					.endif
					invoke	UnmapViewOfFile, pMapping
				.else
					invoke	SetDlgItemText, hDlg, IDC_RESULTAT, offset Resultat_ErrorMapping
				.endif
				invoke	CloseHandle, hMapping
			.else
				invoke	SetDlgItemText, hDlg, IDC_RESULTAT, offset Resultat_ErrorMapping
			.endif
			invoke	CloseHandle, hFile
		.else
			invoke	SetDlgItemText, hDlg, IDC_RESULTAT, offset Resultat_ErrorOpen
		.endif
	.endif	
	ret
OpenTarget	ENDP
; -------------------------------------------------------------------------------
end start